varying vec2 textureCoord;
varying vec4 color;

uniform sampler2D sampler0;
uniform float tolerance;
uniform float smoothing;
uniform vec3 chroma;

void main() {

  vec4 col = texture2D( sampler0, textureCoord )*color;

  float maskY = 0.2989 * chroma.x + 0.5866 * chroma.y + 0.1145 * chroma.z;
  float maskCr = 0.7132 * (chroma.x - maskY);
  float maskCb = 0.5647 * (chroma.y - maskY); 

  float Y = 0.2989 * col.x + 0.5866 * col.y + 0.1145 * col.z;
  float Cr = 0.7132 * (col.x - Y);
  float Cb = 0.5647 * (col.y - Y);

  float blendValue = smoothstep(tolerance, tolerance + smoothing, distance(vec2(Cr, Cb), vec2(maskCr, maskCb)));

  gl_FragColor = vec4(col.xyz * blendValue, 1.0 * blendValue);
}