varying vec2 textureCoord;
varying vec4 color;
uniform sampler2D sampler0;
uniform float seed;
uniform float beat;
uniform float rand;

void main()
{
  if ( seed > 0 )
  {
    float dx = seed*15.*(1./512.);
    float dy = seed*10.*(1./512.);
    vec2 coord = vec2(dx*floor(gl_TexCoord[0].x/dx),dy*floor(gl_TexCoord[0].y/dy));
    gl_FragColor = texture2D(sampler0, coord);
  }
  else if ( seed > -5 )
  {
    gl_FragColor = texture2D(sampler0, textureCoord);
  }
  else if (seed > -15 )
  {
    vec4 col = texture2D( sampler0, textureCoord )*color;
    float gray = dot(col.xyz, vec3(0.299, 0.587, 0.114));
    gl_FragColor = vec4(gray-(gray*rand), gray-(gray*rand), gray-(gray*rand), col.w);
  }
  else
  {
    vec4 col = texture2D( sampler0, textureCoord )*color;
    gl_FragColor = vec4(col.x-(col.x*rand), col.y-(col.y*rand), col.z-(col.z*rand), col.w);
  }
}
