varying vec2 imageCoord;
uniform sampler2D sampler0;
uniform float yo;
uniform vec2 textureSize;
uniform vec2 imageSize;

#define img2tex(v) ( v / textureSize * imageSize )

vec2 Spiral( vec2 p , vec2 o)
    {
    p.x=p.x-o.x;
    p.y=p.y-o.y;
    float r = length(p);
    float theta = atan(p.y, p.x) + ((1/(r*r))*yo*.05);
    float x = r * cos(theta);
    float y = r * sin(theta);
    return vec2(x+o.x, y+o.y);
}

void main()
{
    vec2 origin=imageSize/2;
    gl_FragColor = texture2D(sampler0,img2tex( Spiral( imageCoord, vec2( 0.5, 0.5 ) ) ));
}