#version 120

#define saturate(i) clamp(i,0.,1.)

varying vec2 textureCoord;
varying vec2 imageCoord;

varying vec4 color;

uniform vec2 textureSize;
uniform vec2 imageSize;

uniform sampler2D sampler0;

vec2 texCoord2imgCoord( vec2 uv )
{
  return uv / textureSize * imageSize;
}

uniform float a;
uniform float b;
uniform float t;
uniform float c;

//float3 GrayscalePass( float4 vpos : SV_Position, float2 texcoord : TexCoord ) : SV_Target {
void main(void)
{
  
  vec3 tex = texture2D(sampler0, texCoord2imgCoord(imageCoord)).xyz;
  
  float r = distance( imageCoord.xy, vec2(0.5,0.5) );

  float opacity = 1-pow((1-min(max(0, a*t-b*r), 1)),c);

	gl_FragColor = vec4( tex, opacity )*color;
	
}
